/*
	WriteMailslot.c
	Frank P. Westlake, 2000
*/

#define	PROGRAMNAME	"WRITEMAILSLOT"
#define	BUFLEN	1024
#include	<windows.h>
#include	<local/console.c>	//	ConInit(), ConOut(), ReportError(), ConClose(), fPipe, fRedir, 

HANDLE GetStdIn(HANDLE);

int main(int argc, char *argv[])
{
	HANDLE	hSlot;
	LPSTR		lpMsg=0;
	BOOL		bPipeIn=FALSE;
	ConInit();
	if(fPipe||fRedir)	bPipeIn=TRUE;
	if((bPipeIn && argc!=2) || (!bPipeIn && argc!=3) || !strcmp(argv[1], "/?"))	ConOut(hStdout, "\
Writes a message to a mailslot\n\
\n\
[MessagePipeStream |] "PROGRAMNAME" mailslot [\"message\"] [< MessageFile]\n\
\n\
A mailslot name is of the format:\n\
\n\
  \\\\<computer or domain>\\mailslot\\[pseudo path\\]name\n\
\n\
The computer or domain may be specified by name, or a period \'.\' may be used to\n\
specify the local computer and an asterisk \'*\' may be used to specify the\n\
primary domain. The mailslot must exist on the computer or domain specified.\n\
\n\
Examples:\n\
  "PROGRAMNAME" \\\\YourComputer\\mailslot\\YourSlot       \"My message\"\n\
  TYPE MessageFile | "PROGRAMNAME" \\\\.\\mailslot\\MySlot\n\
  "PROGRAMNAME" \\\\OurDomain\\mailslot\\OurSlots\\YourSlot < MessageFile\n\
  "PROGRAMNAME" \\\\*\\mailslot\\OurSlots\\YourSlot         \"My message\"\n\
");
	else	if((hSlot=CreateFile(argv[1], GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL))!=INVALID_HANDLE_VALUE)
	{
		HANDLE	hMem=0;
		if(bPipeIn)
		{	if((hMem=GetStdIn(hMem))!=NULL)	lpMsg=GlobalLock(hMem);	}
		else	lpMsg=argv[2];
		if(lpMsg)
		{	DWORD	dwWritten;
			if(WriteFile(hSlot, lpMsg, (DWORD) lstrlen(lpMsg)+1, &dwWritten, NULL));
			else
			{	DWORD	dwError;
				if((dwError=GetLastError())==ERROR_INVALID_NETNAME || dwError==ERROR_BAD_NETPATH)	ConOut(hStderr, PROGRAMNAME": Operation aborted. No more than 400 bytes can be sent to a domain.\n");
				else	ReportError("WriteFile ", dwError);
			}	//	else
			if(hMem)	{GlobalUnlock(hMem);	GlobalFree(hMem);}
		}	//	if(lpMsg)
		else	ReportError("Message ", GetLastError());
		CloseHandle(hSlot);
	}
	else	ReportError("CreateFile ", GetLastError());
	ConClose();
	return(0);
}
HANDLE GetStdIn(HANDLE hMem)
{
	LPSTR	lpFile;
	hMem=GlobalAlloc(GHND, 1);
	if(hMem && (lpFile=(LPSTR)LocalAlloc(LPTR, BUFLEN))!=NULL)
	{	LPSTR	lpMem;
		DWORD	dwRead, dwToRead;
		int	i;
		i=0;
		do{
			i++;
			if((hMem=GlobalReAlloc(hMem, i*BUFLEN, GHND))==NULL)	break;
			lpMem=GlobalLock(hMem);
			dwToRead=BUFLEN-1;
			do{
				ZeroMemory(lpFile, BUFLEN);
				ReadFile(hStdin, lpFile, dwToRead, &dwRead, NULL);
				dwToRead-=dwRead;
				lstrcat(lpMem, lpFile);
			}	while(dwToRead && dwRead);
			GlobalUnlock(hMem);
		}	while(dwRead);
		LocalFree(lpFile);
	}	//	if(hMem...
	return(hMem);
}

