/*
	WriteMailslot.c
	Frank P. Westlake, 2000
*/

#define	PROGRAMNAME		"WRITENAMEDPIPE"
#include	<windows.h>
#include	<local/console.c>	//	ConInit(), ConOut(), ReportError(), ConClose(), fPipe, fRedir, 
#define	BUFLEN			CON_MAX_BUFFER_COLUMN
#define	PIPE_TIMEOUT	20000

HANDLE GetStdIn(HANDLE);

int main(int argc, char *argv[])
{
	HANDLE	hPipe;
	LPSTR		lpMsg=0;
	BOOL		bPipeIn=FALSE;
	ConInit();
	if(fPipe||fRedir)	bPipeIn=TRUE;
	if((bPipeIn && argc!=2) || (!bPipeIn && argc<3) || !strcmp(argv[1], "/?"))	ConOut(hStdout, "\
Writes a stream of bytes to a named pipe\n\
\n\
[MessagePipeStream |] "PROGRAMNAME" pipename [\"message\"] [< MessageFile]\n\
\n\
pipename is of the format:\n\
\n\
  \\\\.\\pipe\\[pseudo path\\]name\n\
\n\
A named pipe (byte-mode, duplex) is created on the local computer (\'.\') to be\n\
read by another process in the domain. The program waits for a connection; to\n\
discontinue the wait, press [CTRL c].\n\
\n\
Examples:\n\
  "PROGRAMNAME" \\\\.\\pipe\\MyPipe                   \"My message\"\n\
  "PROGRAMNAME" \\\\.\\pipe\\OurPipes\\YourPipe        \"My message\"\n\
");
	else
	{
		ConOut(hStdout, "Creating... ");
		if((hPipe=CreateNamedPipe(argv[1], PIPE_ACCESS_DUPLEX	, PIPE_TYPE_BYTE | PIPE_READMODE_BYTE | PIPE_WAIT, PIPE_UNLIMITED_INSTANCES, BUFLEN, BUFLEN, PIPE_TIMEOUT, NULL))!=INVALID_HANDLE_VALUE)
		{
			ConOut(hStdout, "Waiting for client ([CTRL c] to cancel)... ");
			if(+ConnectNamedPipe(hPipe, NULL)||(GetLastError()==ERROR_PIPE_CONNECTED))
			{
				HANDLE	hMem=0;
				if(bPipeIn)
				{	if((hMem=GetStdIn(hMem))!=NULL)	lpMsg=GlobalLock(hMem);	}
				else	lpMsg=argv[2];
				if(lpMsg)
				{
					DWORD	dw;
					ConOut(hStdout, "Connected... Writing... ");
					if(WriteFile(hPipe, lpMsg, (DWORD) lstrlen(lpMsg)+1, &dw, NULL));
					else
					{	DWORD	dwError;
						if((dwError=GetLastError())==ERROR_INVALID_NETNAME || dwError==ERROR_BAD_NETPATH)	ConOut(hStderr, PROGRAMNAME": Operation aborted. No more than 400 bytes can be sent to a domain.\n");
						else	ReportError("WriteFile ", dwError);
					}	//	else
					if(hMem)	{GlobalUnlock(hMem);	GlobalFree(hMem);}
					FlushFileBuffers(hPipe);
				}
				else	ReportError("Message ", GetLastError());
				DisconnectNamedPipe(hPipe);
				ConOut(hStdout, "Done.\n");
			}	//	if(ConnectNamedPipe...
			else	ConOut(hStdout, "Unable to connect to a client.\n");
			CloseHandle(hPipe);
		}	//	if(CreateNamedPipe...
	}
	ConClose();
	return(0);
}
HANDLE GetStdIn(HANDLE hMem)
{
	LPSTR	lpFile;
	hMem=GlobalAlloc(GHND, 1);
	if(hMem && (lpFile=(LPSTR)LocalAlloc(LPTR, BUFLEN))!=NULL)
	{	LPSTR	lpMem;
		DWORD	dwRead, dwToRead;
		int	i;
		i=0;
		do{
			i++;
			if((hMem=GlobalReAlloc(hMem, i*BUFLEN, GHND))==NULL)	break;
			lpMem=GlobalLock(hMem);
			dwToRead=BUFLEN-1;
			do{
				ZeroMemory(lpFile, BUFLEN);
				ReadFile(hStdin, lpFile, dwToRead, &dwRead, NULL);
				dwToRead-=dwRead;
				lstrcat(lpMem, lpFile);
			}	while(dwToRead && dwRead);
			GlobalUnlock(hMem);
		}	while(dwRead);
		LocalFree(lpFile);
	}	//	if(hMem...
	return(hMem);
}

